"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const dpdm_1 = require("dpdm");
const testUtils_1 = require("./testUtils");
describe(`Circular dependencies (${(0, testUtils_1.getTestFile)(__filename)})`, function () {
    it("Should not have circular dependencies", async function () {
        const tree = await (0, dpdm_1.parseDependencyTree)("./src/index.ts", {
            // Transform typescript to javascript before checking for circular dependencies (avoid type circular deps)
            transform: true,
        });
        const circulars = (0, dpdm_1.parseCircular)(tree);
        const prettyCircularRes = (0, dpdm_1.prettyCircular)(circulars);
        (0, chai_1.expect)(prettyCircularRes).to.eq("");
    });
});
//# sourceMappingURL=circularDep.test.js.map